/*
** oidentd_net_util.h - oidentd network utility functions.
** Copyright (C) 2001 Ryan McCabe <odin@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
**
** $Id: oidentd_inet_util.h,v 1.5 2001/07/25 20:21:38 odin Exp $
*/

#ifndef __OIDENTD_INET_UTIL_H
#define __OIDENTD_INET_UTIL_H

#define SIN4(x) ((struct sockaddr_in *) (x))
#define SIN6(x) ((struct sockaddr_in6 *) (x))

int setup_listen(in_port_t listen_port, struct sockaddr_storage *listen_addr);
int get_port(const u_char *name, in_port_t *port);
int get_addr(const u_char *const hostname, struct sockaddr_storage *g_addr);
void get_ip(struct sockaddr_storage *ss, u_char *buf, size_t len);

int get_hostname(	struct sockaddr_storage *addr,
					u_char *hostname,
					size_t len);

int sockprintf(int fd, char *fmt, ...);
ssize_t sock_read(int fd, u_char *srbuf, size_t len);
ssize_t sock_write(int sock, void *buf, size_t len);

#ifndef HAVE_INET_ATON
	int inet_aton(const char *cp, struct in_addr *addr);
#endif

#ifdef WANT_IPV6
	inline void sin_extractv4(struct in6_addr *sin6, struct in_addr *sin4);
	void sin_setv6(struct in6_addr *sin6, struct sockaddr_storage *ss);
#endif

void sin_setv4(in_addr_t addr, struct sockaddr_storage *ss);
void sin_copy(struct sockaddr_storage *ss1, const struct sockaddr_storage *ss2);
void *sin_addr(struct sockaddr_storage *ss);
in_port_t sin_port(const struct sockaddr_storage *ss);
void sin_set_port(in_port_t port, struct sockaddr_storage *ss);
bool sin_equal(	struct sockaddr_storage *ss1,
				struct sockaddr_storage *ss2);

#endif
